package jsr.daemon;

/**
 * interface for a service providing container in order to control the life cycle of a daemon
 *
 * @author   Thomas Kopp
 * @version  0.9, 2000-11-16
 */
public interface DaemonControl {

    /**
     * initialization method called in order to initialize and start a daemon
     * @exception DaemonException thrown by the daemon if initialization fails
     */
    public void init() throws DaemonException;

    /**
     * destruction method called in order to stop and shutdown a daemon
     */
    public void destroy();
}
